Subject: Re: Flash upload to ebsa285

From: David A Rusling <[email-masked]>
Date: Thu, 11 Feb 1999 10:14:13 +0000

At 11:09 PM 2/10/99 +0000, Russell King - ARM Linux Admin wrote:
>Mark van Doesburg writes:
>> 	christophe wrote: I've got an ebsa285 card but not the ARM SDT
>> 	(only got the demonstration version, which doesn't have angel
>> 	remote_a)
>> 
>> 	Is there any Linux tool or free dos tool to upload Linux kernel
>> 	to ebsa285 flash memory ?
>> 
>> I've created a very crude program to program the flash in the blank
>> programming mode. It has a module you have to load in order to access
>> the ROM. To program you have to run a simple program which allows you to
>> crash your computer if you get the address wrong :-) Let me know if
>> you're interested.
>
>I do have a working version of Digital's FMU (flash management utility)
>which works under Linux on the EBSA285.  However, Digital have put a non-
>freely distributable license on it, so I'm unable to distribute it.
>

You can reference it on the web though.

>Since the license has been transferred to Intel, what are the chances
>of getting it changed? 0?

Good question, I'll ask.  A better question (at least to me) is what
is ARM's view of low level firmware, utilities and open source?

Dave

>   _____
>  |_____| ------------------------------------------------- ---+---+-
>  |   |        Russell King       [email-masked]      --- ---
>  | | | |  http://www.arm.linux.org.uk/~rmk/armlinux.html    /  /  |
>  | +-+-+                                                     --- -+-
>  /   |               THE developer of ARM Linux              |+| /|\
> /  | | |                                                     ---  |
>    +-+-+ -------------------------------------------------  /\\\  |
>unsubscribe: body of `unsubscribe linux-arm' to [email-masked]
>
>
----------------------------------------------------------------------
David A Rusling		Consulting Engineer
				ARM Limited
				Liberty House,
				Moorbridge Road,
				Maidenhead, SL6 8LT

				Tel: UK-(0)1628-427754
				Fax: UK-(0)1628-780551
				e-mail: [email-masked]
----------------------------------------------------------------------
unsubscribe: body of `unsubscribe linux-arm' to [email-masked]

---

From: Russell King <[email-masked]>
Date: Thu, 11 Feb 1999 22:02:35 +0000 (GMT)

Andrew Thomas said:
> Can someone out there who is running a linux kernel on an EBSA285
> board please explain how to take the vmlinux generated by 'make all'
> and get the thing to boot on an ebsa285 using tools which are publicly
> available. [Sorry if I sound frustrated only I'm trying to write my
> own boot loader (for linnux for an ebsa285) and is driving me cRaZYYY
> :-)]

Firstly, you should not be using the vmlinux file generated by 'make all'.
There is a binary image generated by 'make Image', called arch/arm/boot/Image
This is the file I use.

My EBSA285 is configured in Central Function mode, which means it is the
main processor in the system.  This allows it to configure the PCI cards.
I also have an ethernet card, and a utility called 'angelboot' which can
be used to download programs over the serial port.

Initially, I wrote a small ethernet boot loader for the EBSA-110 board,
and I adapted it for use with the EBSA285.  I frigged the build to get
the file to look like an AIF binary format which 'angelboot' will accept.

I downloaded this image which then in turn pulled the kernel off of
another machine via BOOTP and TFTP.  Once the kernel was running, at
the earliest opportunity, I programmed this loader into the EBSA285's
flash at image 2.

Later, once the kernel was stable, I generated what is almost a BIOS for
EBSA825 boards, but it is very limited to the hardware - it only supports
Promise UDMA IDE cards, 3com 3c509 and (very limited number of) Tulip ether
cards, and a S3 Trio64V2 VGA card.  I now have this programmed into flash
image 3, and it does all the hardware initialisation and kernel fetching.

Depending on what machines you have available, you will want to follow
a different path.  I would recommend, if you have the ARM SDT, generating
a program to load the kernel either over the PCI bus (if you have it in
a PC), or if you only have a serial port and ethernet card, developing
a very small TFTP loader.  I wouldn't recommend using the serial port
to transfer a large kernel - it'll take a long time to load it each
time.

I hope this helps.

> Note, the dos fmu tools etc. are available on Intels web site.
> (follow links from
> http://developer.intel.com/design/strong/sa-evaldownload.htm )

However, these are useless if you want to run them natively on the board
(they're only for x86 PCs or other CPUs, but not ARMs).

--
Russell King ([email-masked])
unsubscribe: body of `unsubscribe linux-arm' to [email-masked]

---

From: Russell King - ARM Linux Admin <[email-masked]>
Date: Thu, 11 Feb 1999 23:21:43 +0000 (GMT)

Mark van Doesburg writes:
> You can use: 
> 	arm-linux-objcopy vmlinux -O binary kernel_image

However, that's exactly what make Image does. ;)
   _____